(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('bootstrap/dist/js/bootstrap.bundle'), require('bootstrap/js/src/util'), require('bootstrap/js/src/dom/data'), require('bootstrap/js/src/dom/event-handler'), require('bootstrap/js/src/dom/manipulator'), require('bootstrap/js/src/dom/selector-engine'), require('bootstrap/js/src/base-component'), require('bootstrap/js/src/collapse')) :
  typeof define === 'function' && define.amd ? define(['exports', 'bootstrap/dist/js/bootstrap.bundle', 'bootstrap/js/src/util', 'bootstrap/js/src/dom/data', 'bootstrap/js/src/dom/event-handler', 'bootstrap/js/src/dom/manipulator', 'bootstrap/js/src/dom/selector-engine', 'bootstrap/js/src/base-component', 'bootstrap/js/src/collapse'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.kit = {}, null, global.util, global.Data, global.EventHandler, global.Manipulator, global.SelectorEngine, global.BaseComponent, global.Collapse));
}(this, (function (exports, bootstrap_bundle, util, Data, EventHandler, Manipulator, SelectorEngine, BaseComponent, Collapse) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var Data__default = /*#__PURE__*/_interopDefaultLegacy(Data);
  var EventHandler__default = /*#__PURE__*/_interopDefaultLegacy(EventHandler);
  var Manipulator__default = /*#__PURE__*/_interopDefaultLegacy(Manipulator);
  var SelectorEngine__default = /*#__PURE__*/_interopDefaultLegacy(SelectorEngine);
  var BaseComponent__default = /*#__PURE__*/_interopDefaultLegacy(BaseComponent);
  var Collapse__default = /*#__PURE__*/_interopDefaultLegacy(Collapse);

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME$5 = 'affix';
  var DATA_KEY$5 = 'bs.affix';
  var EVENT_KEY$5 = "." + DATA_KEY$5;
  var DATA_API_KEY$5 = '.data-api';
  var Default$4 = {
    offset: 0,
    target: window
  };
  var DefaultType$4 = {
    offset: 'number',
    target: 'string'
  };
  var SELECTOR_SPY = '[data-bs-spy="affix"]';
  var EVENT_SCROLL$2 = "scroll" + EVENT_KEY$5;
  var EVENT_LOAD_DATA_API$4 = "load" + EVENT_KEY$5 + DATA_API_KEY$5;
  var EVENT_CLICK_DATA_API$1 = "click" + EVENT_KEY$5 + DATA_API_KEY$5;
  var CLASS_NAME_AFFIX = 'affix';
  var CLASS_NAME_AFFIX_TOP = 'affix-top';
  var CLASS_NAME_AFFIX_BOTTOM = 'affix-bottom';
  /**
   * ------------------------------------------------------------------------
   * Class Definition
   * ------------------------------------------------------------------------
   */

  var Affix = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(Affix, _BaseComponent);

    function Affix(element, config) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;
      _this.target = SelectorEngine__default['default'].findOne(config.target);
      _this.affixed = null;
      _this.unpin = null;
      _this.pinnedOffset = null;
      _this._config = _this._getConfig(config);

      _this._addEventListeners();

      _this.checkPosition();

      return _this;
    } // Getters


    var _proto = Affix.prototype;

    // Public
    // Private
    _proto._getConfig = function _getConfig(config) {
      config = _extends({}, Default$4, config);
      util.typeCheckConfig(NAME$5, config, DefaultType$4);
      return config;
    };

    _proto._addEventListeners = function _addEventListeners() {
      EventHandler__default['default'].on(this.target, EVENT_SCROLL$2, this.checkPosition.bind(this));
      EventHandler__default['default'].on(this.target, EVENT_CLICK_DATA_API$1, this.checkPositionWithEventLoop.bind(this));
    } // Static
    ;

    Affix.affixInterface = function affixInterface(element, config) {
      var data = Data__default['default'].get(element, DATA_KEY$5);

      var _config = _extends({}, Default$4, Manipulator__default['default'].getDataAttributes(element));

      if (typeof config === 'object') {
        _config = _extends({}, _config, config);
      }

      if (!data) {
        data = new Affix(element, _config);
      }
    };

    Affix.jQueryInterface = function jQueryInterface(config) {
      return this.each(function () {
        Affix.affixInterface(this, config);
      });
    };

    Affix.getState = function getState(scrollHeight, height, offsetTop, offsetBottom) {
      var _this$target = this.target,
          scrollTop = _this$target.scrollTop,
          offsetHeight = _this$target.offsetHeight;
      var position = {
        top: this._element.offsetTop,
        left: this._element.offsetLeft
      };
      var targetHeight = offsetHeight;

      if (offsetTop !== undefined && this.affixed === 'top') {
        return scrollTop < offsetTop ? 'top' : false;
      }

      if (this.affixed === 'bottom') {
        if (offsetTop !== undefined) {
          return scrollTop + this.unpin <= position.top ? false : 'bottom';
        }

        return scrollTop + targetHeight <= scrollHeight - offsetBottom ? false : 'bottom';
      }

      var initializing = this.affixed === undefined;
      var colliderTop = initializing ? scrollTop : position.top;
      var colliderHeight = initializing ? targetHeight : height;

      if (offsetTop !== undefined && scrollTop <= offsetTop) {
        return 'top';
      }

      if (offsetBottom !== undefined && colliderTop + colliderHeight >= scrollHeight - offsetBottom) {
        return 'bottom';
      }

      return false;
    };

    Affix.getPinnedOffset = function getPinnedOffset() {
      if (this.pinnedOffset) {
        return this.pinnedOffset;
      }

      this._element.classList.remove(CLASS_NAME_AFFIX_TOP, CLASS_NAME_AFFIX_BOTTOM);

      this._element.classList.add(CLASS_NAME_AFFIX);

      var scrollTop = this.target.scrollTop;
      var position = {
        top: this._element.offsetTop,
        left: this._element.offsetLeft
      };
      this.pinnedOffset = position.top - scrollTop;
      return this.pinnedOffset;
    };

    Affix.checkPositionWithEventLoop = function checkPositionWithEventLoop() {
      setTimeout(this.checkPosition.bind(this), 1);
    };

    Affix.checkPosition = function checkPosition() {
      if (!util.isVisible(this._element)) {
        return;
      }

      var height = this._element.offsetHeight;
      var offset = this._config.offset;
      var offsetTop = offset.top;
      var offsetBottom = offset.bottom;
      var scrollHeight = Math.max(document.offsetHeight, document.body.offsetHeight);

      if (typeof offset !== 'object') {
        offsetTop = offset;
        offsetBottom = offset;
      }

      if (typeof offsetTop === 'function') {
        offsetTop = offset.top(this._element);
      }

      if (typeof offsetBottom === 'function') {
        offsetBottom = offset.bottom(this._element);
      }

      var affix = this.getState(scrollHeight, height, offsetTop, offsetBottom);

      if (this.affixed !== affix) {
        if (this.unpin !== undefined) {
          this._element.style.top = '';
        }

        var affixType = 'affix' + (affix ? '-' + affix : '');
        EventHandler__default['default'].trigger(this._element, "" + affixType + EVENT_KEY$5); // Is default prevented? Return

        this.affixed = affix;
        this.unpin = affix === 'bottom' ? this.getPinnedOffset() : null;

        this._element.classList.remove(CLASS_NAME_AFFIX, CLASS_NAME_AFFIX_TOP, CLASS_NAME_AFFIX_BOTTOM);

        this._element.classList.add(affixType);

        EventHandler__default['default'].trigger(this._element, "" + affixType.replace('affix', 'affixed') + EVENT_KEY$5);
      }

      if (affix === 'bottom') {
        this._element.style.top = scrollHeight - height - offsetBottom;
      }
    };

    _createClass(Affix, null, [{
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY$5;
      }
    }]);

    return Affix;
  }(BaseComponent__default['default']);
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(window, EVENT_LOAD_DATA_API$4, function () {
    var affixes = SelectorEngine__default['default'].find(SELECTOR_SPY);

    for (var i = 0, len = affixes.length; i < len; i++) {
      Affix.carouselInterface(affixes[i], Data__default['default'].get(affixes[i], DATA_KEY$5));
    }
  });
  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   * add .Affix to jQuery only if jQuery is present
   */

  util.defineJQueryPlugin(NAME$5, Affix);

  /* =========================================================
   * bootstrap-datepicker.js
   * Repo: https://github.com/eternicode/bootstrap-datepicker/
   * Demo: http://eternicode.github.io/bootstrap-datepicker/
   * Docs: http://bootstrap-datepicker.readthedocs.org/
   * Forked from http://www.eyecon.ro/bootstrap-datepicker
   * =========================================================
   * Started by Stefan Petre; improvements by Andrew Rowls + contributors
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   * http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   * ========================================================= */

  /* eslint-disable unicorn/no-abusive-eslint-disable */

  /* eslint-disable */
  (function ($, undefined$1) {
    function UTCDate() {
      return new Date(Date.UTC.apply(Date, arguments));
    }

    function UTCToday() {
      var today = new Date();
      return UTCDate(today.getFullYear(), today.getMonth(), today.getDate());
    }

    function isUTCEquals(date1, date2) {
      return date1.getUTCFullYear() === date2.getUTCFullYear() && date1.getUTCMonth() === date2.getUTCMonth() && date1.getUTCDate() === date2.getUTCDate();
    }

    function alias(method) {
      return function () {
        return Reflect.apply(this[method], this, arguments);
      };
    }

    var DateArray = function () {
      var extras = {
        get: function get(i) {
          return this.slice(i)[0];
        },
        contains: function contains(d) {
          // Array.indexOf is not cross-browser;
          // $.inArray doesn't work with Dates
          var val = d && d.valueOf();

          for (var i = 0, l = this.length; i < l; i++) {
            if (this[i].valueOf() === val) {
              return i;
            }
          }

          return -1;
        },
        remove: function remove(i) {
          this.splice(i, 1);
        },
        replace: function replace(new_array) {
          if (!new_array) {
            return;
          }

          if (!$.isArray(new_array)) {
            new_array = [new_array];
          }

          this.clear();
          this.push.apply(this, new_array);
        },
        clear: function clear() {
          this.length = 0;
        },
        copy: function copy() {
          var a = new DateArray();
          a.replace(this);
          return a;
        }
      };
      return function () {
        var a = [];
        a.push.apply(a, arguments);
        $.extend(a, extras);
        return a;
      };
    }(); // Picker object


    var Datepicker = function Datepicker(element, options) {
      this._process_options(options);

      this.dates = new DateArray();
      this.viewDate = this.o.defaultViewDate;
      this.focusDate = null;
      this.element = $(element);
      this.isInline = false;
      this.isInput = this.element.is('input');
      this.component = this.element.hasClass('date') ? this.element.find('.add-on, .input-group-addon, .btn') : false;
      this.hasInput = this.component && this.element.find('input').length;

      if (this.component && this.component.length === 0) {
        this.component = false;
      }

      this.picker = $(DPGlobal.template);

      this._buildEvents();

      this._attachEvents();

      if (this.isInline) {
        this.picker.addClass('datepicker-inline').appendTo(this.element);
      } else {
        this.picker.addClass('datepicker-dropdown dropdown-menu');
      }

      if (this.o.rtl) {
        this.picker.addClass('datepicker-rtl');
      }

      this.viewMode = this.o.startView;

      if (this.o.calendarWeeks) {
        this.picker.find('tfoot .today, tfoot .clear').attr('colspan', function (i, val) {
          return Number.parseInt(val) + 1;
        });
      }

      this._allow_update = false;
      this.setStartDate(this._o.startDate);
      this.setEndDate(this._o.endDate);
      this.setDaysOfWeekDisabled(this.o.daysOfWeekDisabled);
      this.setDatesDisabled(this.o.datesDisabled);
      this.fillDow();
      this.fillMonths();
      this._allow_update = true;
      this.update();
      this.showMode();

      if (this.isInline) {
        this.show();
      }
    };

    Datepicker.prototype = {
      constructor: Datepicker,
      _process_options: function _process_options(opts) {
        // Store raw options for reference
        this._o = $.extend({}, this._o, opts); // Processed options

        var o = this.o = $.extend({}, this._o); // Check if "de-DE" style date is available, if not language should
        // fallback to 2 letter code eg "de"

        var lang = o.language;

        if (!dates[lang]) {
          lang = lang.split('-')[0];

          if (!dates[lang]) {
            lang = defaults.language;
          }
        }

        o.language = lang;

        switch (o.startView) {
          case 2:
          case 'decade':
            o.startView = 2;
            break;

          case 1:
          case 'year':
            o.startView = 1;
            break;

          default:
            o.startView = 0;
        }

        switch (o.minViewMode) {
          case 1:
          case 'months':
            o.minViewMode = 1;
            break;

          case 2:
          case 'years':
            o.minViewMode = 2;
            break;

          default:
            o.minViewMode = 0;
        }

        o.startView = Math.max(o.startView, o.minViewMode); // True, false, or Number > 0

        if (o.multidate !== true) {
          o.multidate = Number(o.multidate) || false;

          if (o.multidate !== false) {
            o.multidate = Math.max(0, o.multidate);
          }
        }

        o.multidateSeparator = String(o.multidateSeparator);
        o.weekStart %= 7;
        o.weekEnd = (o.weekStart + 6) % 7;
        var format = DPGlobal.parseFormat(o.format);

        if (o.startDate !== Number.NEGATIVE_INFINITY) {
          if (o.startDate) {
            o.startDate = o.startDate instanceof Date ? this._local_to_utc(this._zero_time(o.startDate)) : DPGlobal.parseDate(o.startDate, format, o.language);
          } else {
            o.startDate = Number.NEGATIVE_INFINITY;
          }
        }

        if (o.endDate !== Number.POSITIVE_INFINITY) {
          if (o.endDate) {
            o.endDate = o.endDate instanceof Date ? this._local_to_utc(this._zero_time(o.endDate)) : DPGlobal.parseDate(o.endDate, format, o.language);
          } else {
            o.endDate = Number.POSITIVE_INFINITY;
          }
        }

        o.daysOfWeekDisabled = o.daysOfWeekDisabled || [];

        if (!$.isArray(o.daysOfWeekDisabled)) {
          o.daysOfWeekDisabled = o.daysOfWeekDisabled.split(/[\s,]*/);
        }

        o.daysOfWeekDisabled = $.map(o.daysOfWeekDisabled, function (d) {
          return Number.parseInt(d, 10);
        });
        o.datesDisabled = o.datesDisabled || [];

        if (!$.isArray(o.datesDisabled)) {
          var datesDisabled = [];
          datesDisabled.push(DPGlobal.parseDate(o.datesDisabled, format, o.language));
          o.datesDisabled = datesDisabled;
        }

        o.datesDisabled = $.map(o.datesDisabled, function (d) {
          return DPGlobal.parseDate(d, format, o.language);
        });
        var plc = String(o.orientation).toLowerCase().split(/\s+/g);

        var _plc = o.orientation.toLowerCase();

        plc = $.grep(plc, function (word) {
          return /^auto|left|right|top|bottom$/.test(word);
        });
        o.orientation = {
          x: 'auto',
          y: 'auto'
        };

        if (!_plc || _plc === 'auto') ; // No action
        else if (plc.length === 1) {
            switch (plc[0]) {
              case 'top':
              case 'bottom':
                o.orientation.y = plc[0];
                break;

              case 'left':
              case 'right':
                o.orientation.x = plc[0];
                break;
            }
          } else {
            _plc = $.grep(plc, function (word) {
              return /^left|right$/.test(word);
            });
            o.orientation.x = _plc[0] || 'auto';
            _plc = $.grep(plc, function (word) {
              return /^top|bottom$/.test(word);
            });
            o.orientation.y = _plc[0] || 'auto';
          }

        if (o.defaultViewDate) {
          var year = o.defaultViewDate.year || new Date().getFullYear();
          var month = o.defaultViewDate.month || 0;
          var day = o.defaultViewDate.day || 1;
          o.defaultViewDate = UTCDate(year, month, day);
        } else {
          o.defaultViewDate = UTCToday();
        }

        o.showOnFocus = o.showOnFocus !== undefined$1 ? o.showOnFocus : true;
      },
      _events: [],
      _secondaryEvents: [],
      _applyEvents: function _applyEvents(evs) {
        for (var i = 0, el, ch, ev; i < evs.length; i++) {
          el = evs[i][0];

          if (evs[i].length === 2) {
            ch = undefined$1;
            ev = evs[i][1];
          } else if (evs[i].length === 3) {
            ch = evs[i][1];
            ev = evs[i][2];
          }

          el.on(ev, ch);
        }
      },
      _unapplyEvents: function _unapplyEvents(evs) {
        for (var i = 0, el, ev, ch; i < evs.length; i++) {
          el = evs[i][0];

          if (evs[i].length === 2) {
            ch = undefined$1;
            ev = evs[i][1];
          } else if (evs[i].length === 3) {
            ch = evs[i][1];
            ev = evs[i][2];
          }

          el.off(ev, ch);
        }
      },
      _buildEvents: function _buildEvents() {
        var events = {
          keyup: $.proxy(function (e) {
            if ($.inArray(e.keyCode, [27, 37, 39, 38, 40, 32, 13, 9]) === -1) {
              this.update();
            }
          }, this),
          keydown: $.proxy(this.keydown, this)
        };

        if (this.o.showOnFocus === true) {
          events.focus = $.proxy(this.show, this);
        }

        if (this.isInput) {
          // Single input
          this._events = [[this.element, events]];
        } else if (this.component && this.hasInput) {
          // Component: input + button
          this._events = [// For components that are not readonly, allow keyboard nav
          [this.element.find('input'), events], [this.component, {
            click: $.proxy(this.show, this)
          }]];
        } else if (this.element.is('div')) {
          // Inline datepicker
          this.isInline = true;
        } else {
          this._events = [[this.element, {
            click: $.proxy(this.show, this)
          }]];
        }

        this._events.push( // Component: listen for blur on element descendants
        [this.element, '*', {
          blur: $.proxy(function (e) {
            this._focused_from = e.target;
          }, this)
        }], // Input: listen for blur on element
        [this.element, {
          blur: $.proxy(function (e) {
            this._focused_from = e.target;
          }, this)
        }]);

        this._secondaryEvents = [[this.picker, {
          click: $.proxy(this.click, this)
        }], [$(window), {
          resize: $.proxy(this.place, this)
        }], [$(document), {
          'mousedown touchstart': $.proxy(function (e) {
            // Clicked outside the datepicker, hide it
            if (!(this.element.is(e.target) || this.element.find(e.target).length > 0 || this.picker.is(e.target) || this.picker.find(e.target).length > 0)) {
              this.hide();
            }
          }, this)
        }]];
      },
      _attachEvents: function _attachEvents() {
        this._detachEvents();

        this._applyEvents(this._events);
      },
      _detachEvents: function _detachEvents() {
        this._unapplyEvents(this._events);
      },
      _attachSecondaryEvents: function _attachSecondaryEvents() {
        this._detachSecondaryEvents();

        this._applyEvents(this._secondaryEvents);
      },
      _detachSecondaryEvents: function _detachSecondaryEvents() {
        this._unapplyEvents(this._secondaryEvents);
      },
      _trigger: function _trigger(event, altdate) {
        var date = altdate || this.dates.get(-1);

        var local_date = this._utc_to_local(date);

        this.element.trigger({
          type: event,
          date: local_date,
          dates: $.map(this.dates, this._utc_to_local),
          format: $.proxy(function (ix, format) {
            if (arguments.length === 0) {
              ix = this.dates.length - 1;
              format = this.o.format;
            } else if (typeof ix === 'string') {
              format = ix;
              ix = this.dates.length - 1;
            }

            format = format || this.o.format;
            var date = this.dates.get(ix);
            return DPGlobal.formatDate(date, format, this.o.language);
          }, this)
        });
      },
      show: function show() {
        if (this.element.attr('readonly')) {
          return;
        }

        if (!this.isInline) {
          this.picker.appendTo(this.o.container);
        }

        this.place();
        this.picker.show();

        this._attachSecondaryEvents();

        this._trigger('show');

        if ((window.navigator.msMaxTouchPoints || 'ontouchstart' in document) && this.o.disableTouchKeyboard) {
          $(this.element).blur();
        }

        return this;
      },
      hide: function hide() {
        if (this.isInline) {
          return this;
        }

        if (!this.picker.is(':visible')) {
          return this;
        }

        this.focusDate = null;
        this.picker.hide().detach();

        this._detachSecondaryEvents();

        this.viewMode = this.o.startView;
        this.showMode();

        if (this.o.forceParse && (this.isInput && this.element.val() || this.hasInput && this.element.find('input').val())) {
          this.setValue();
        }

        this._trigger('hide');

        return this;
      },
      remove: function remove() {
        this.hide();

        this._detachEvents();

        this._detachSecondaryEvents();

        this.picker.remove();
        delete this.element.data().datepicker;

        if (!this.isInput) {
          delete this.element.data().date;
        }

        return this;
      },
      _utc_to_local: function _utc_to_local(utc) {
        return utc && new Date(utc.getTime() + utc.getTimezoneOffset() * 60000);
      },
      _local_to_utc: function _local_to_utc(local) {
        return local && new Date(local.getTime() - local.getTimezoneOffset() * 60000);
      },
      _zero_time: function _zero_time(local) {
        return local && new Date(local.getFullYear(), local.getMonth(), local.getDate());
      },
      _zero_utc_time: function _zero_utc_time(utc) {
        return utc && new Date(Date.UTC(utc.getUTCFullYear(), utc.getUTCMonth(), utc.getUTCDate()));
      },
      getDates: function getDates() {
        return $.map(this.dates, this._utc_to_local);
      },
      getUTCDates: function getUTCDates() {
        return $.map(this.dates, function (d) {
          return new Date(d);
        });
      },
      getDate: function getDate() {
        return this._utc_to_local(this.getUTCDate());
      },
      getUTCDate: function getUTCDate() {
        var selected_date = this.dates.get(-1);

        if (typeof selected_date !== 'undefined') {
          return new Date(selected_date);
        }

        return null;
      },
      clearDates: function clearDates() {
        var element;

        if (this.isInput) {
          element = this.element;
        } else if (this.component) {
          element = this.element.find('input');
        }

        if (element) {
          element.val('').change();
        }

        this.update();

        this._trigger('changeDate');

        if (this.o.autoclose) {
          this.hide();
        }
      },
      setDates: function setDates() {
        var args = $.isArray(arguments[0]) ? arguments[0] : arguments;
        this.update.apply(this, args);

        this._trigger('changeDate');

        this.setValue();
        return this;
      },
      setUTCDates: function setUTCDates() {
        var args = $.isArray(arguments[0]) ? arguments[0] : arguments;
        this.update.apply(this, $.map(args, this._utc_to_local));

        this._trigger('changeDate');

        this.setValue();
        return this;
      },
      setDate: alias('setDates'),
      setUTCDate: alias('setUTCDates'),
      setValue: function setValue() {
        var formatted = this.getFormattedDate();

        if (!this.isInput) {
          if (this.component) {
            this.element.find('input').val(formatted).change();
          }
        } else {
          this.element.val(formatted).change();
        }

        return this;
      },
      getFormattedDate: function getFormattedDate(format) {
        if (format === undefined$1) {
          format = this.o.format;
        }

        var lang = this.o.language;
        return $.map(this.dates, function (d) {
          return DPGlobal.formatDate(d, format, lang);
        }).join(this.o.multidateSeparator);
      },
      setStartDate: function setStartDate(startDate) {
        this._process_options({
          startDate: startDate
        });

        this.update();
        this.updateNavArrows();
        return this;
      },
      setEndDate: function setEndDate(endDate) {
        this._process_options({
          endDate: endDate
        });

        this.update();
        this.updateNavArrows();
        return this;
      },
      setDaysOfWeekDisabled: function setDaysOfWeekDisabled(daysOfWeekDisabled) {
        this._process_options({
          daysOfWeekDisabled: daysOfWeekDisabled
        });

        this.update();
        this.updateNavArrows();
        return this;
      },
      setDatesDisabled: function setDatesDisabled(datesDisabled) {
        this._process_options({
          datesDisabled: datesDisabled
        });

        this.update();
        this.updateNavArrows();
      },
      place: function place() {
        if (this.isInline) {
          return this;
        }

        var calendarWidth = this.picker.outerWidth();
        var calendarHeight = this.picker.outerHeight();
        var visualPadding = 10;
        var windowWidth = $(this.o.container).width();
        var windowHeight = $(this.o.container).height();
        var scrollTop = $(this.o.container).scrollTop();
        var appendOffset = $(this.o.container).offset();
        var parentsZindex = [];
        this.element.parents().each(function () {
          var itemZIndex = $(this).css('z-index');

          if (itemZIndex !== 'auto' && itemZIndex !== 0) {
            parentsZindex.push(Number.parseInt(itemZIndex));
          }
        });
        var zIndex = Math.max.apply(Math, parentsZindex) + 10;
        var offset = this.component ? this.component.parent().offset() : this.element.offset();
        var height = this.component ? this.component.outerHeight(true) : this.element.outerHeight(false);
        var width = this.component ? this.component.outerWidth(true) : this.element.outerWidth(false);
        var left = offset.left - appendOffset.left;
        var top = offset.top - appendOffset.top;
        this.picker.removeClass('datepicker-orient-top datepicker-orient-bottom ' + 'datepicker-orient-right datepicker-orient-left');

        if (this.o.orientation.x !== 'auto') {
          this.picker.addClass('datepicker-orient-' + this.o.orientation.x);

          if (this.o.orientation.x === 'right') {
            left -= calendarWidth - width;
          }
        } // Auto x orientation is best-placement: if it crosses a window
        // edge, fudge it sideways
        else if (offset.left < 0) {
            // Component is outside the window on the left side. Move it into visible range
            this.picker.addClass('datepicker-orient-left');
            left -= offset.left - visualPadding;
          } else if (left + calendarWidth > windowWidth) {
            // The calendar passes the widow right edge. Align it to component right side
            this.picker.addClass('datepicker-orient-right');
            left = offset.left + width - calendarWidth;
          } else {
            // Default to left
            this.picker.addClass('datepicker-orient-left');
          } // Auto y orientation is best-situation: top or bottom, no fudging,
        // decision based on which shows more of the calendar


        var yorient = this.o.orientation.y;
        var top_overflow;
        var bottom_overflow;

        if (yorient === 'auto') {
          top_overflow = -scrollTop + top - calendarHeight;
          bottom_overflow = scrollTop + windowHeight - (top + height + calendarHeight);
          yorient = Math.max(top_overflow, bottom_overflow) === bottom_overflow ? 'top' : 'bottom';
        }

        this.picker.addClass('datepicker-orient-' + yorient);

        if (yorient === 'top') {
          top += height;
        } else {
          top -= calendarHeight + Number.parseInt(this.picker.css('padding-top'));
        }

        if (this.o.rtl) {
          var right = windowWidth - (left + width);
          this.picker.css({
            top: top,
            right: right,
            zIndex: zIndex
          });
        } else {
          this.picker.css({
            top: top,
            left: left,
            zIndex: zIndex
          });
        }

        return this;
      },
      _allow_update: true,
      update: function update() {
        if (!this._allow_update) {
          return this;
        }

        var oldDates = this.dates.copy();
        var dates = [];
        var fromArgs = false;

        if (arguments.length > 0) {
          $.each(arguments, $.proxy(function (i, date) {
            if (date instanceof Date) {
              date = this._local_to_utc(date);
            }

            dates.push(date);
          }, this));
          fromArgs = true;
        } else {
          dates = this.isInput ? this.element.val() : this.element.data('date') || this.element.find('input').val();
          dates = dates && this.o.multidate ? dates.split(this.o.multidateSeparator) : [dates];
          delete this.element.data().date;
        }

        dates = $.map(dates, $.proxy(function (date) {
          return DPGlobal.parseDate(date, this.o.format, this.o.language);
        }, this));
        dates = $.grep(dates, $.proxy(function (date) {
          return date < this.o.startDate || date > this.o.endDate || !date;
        }, this), true);
        this.dates.replace(dates);

        if (this.dates.length > 0) {
          this.viewDate = new Date(this.dates.get(-1));
        } else if (this.viewDate < this.o.startDate) {
          this.viewDate = new Date(this.o.startDate);
        } else if (this.viewDate > this.o.endDate) {
          this.viewDate = new Date(this.o.endDate);
        }

        if (fromArgs) {
          // Setting date by clicking
          this.setValue();
        } else if (dates.length > 0 && // Setting date by typing
        String(oldDates) !== String(this.dates)) {
          this._trigger('changeDate');
        }

        if (this.dates.length === 0 && oldDates.length > 0) {
          this._trigger('clearDate');
        }

        this.fill();
        return this;
      },
      fillDow: function fillDow() {
        var dowCnt = this.o.weekStart;
        var html = '<tr>';

        if (this.o.calendarWeeks) {
          this.picker.find('.datepicker-days thead tr:first-child .datepicker-switch').attr('colspan', function (i, val) {
            return Number.parseInt(val) + 1;
          });
          var cell = '<th class="cw">&#160;</th>';
          html += cell;
        }

        while (dowCnt < this.o.weekStart + 7) {
          html += '<th class="dow">' + dates[this.o.language].daysMin[dowCnt++ % 7] + '</th>';
        }

        html += '</tr>';
        this.picker.find('.datepicker-days thead').append(html);
      },
      fillMonths: function fillMonths() {
        var html = '';
        var i = 0;

        while (i < 12) {
          html += '<span class="month">' + dates[this.o.language].monthsShort[i++] + '</span>';
        }

        this.picker.find('.datepicker-months td').html(html);
      },
      setRange: function setRange(range) {
        if (!range || range.length === 0) {
          delete this.range;
        } else {
          this.range = $.map(range, function (d) {
            return d.valueOf();
          });
        }

        this.fill();
      },
      getClassNames: function getClassNames(date) {
        var cls = [];
        var year = this.viewDate.getUTCFullYear();
        var month = this.viewDate.getUTCMonth();
        var today = new Date();

        if (date.getUTCFullYear() < year || date.getUTCFullYear() === year && date.getUTCMonth() < month) {
          cls.push('old');
        } else if (date.getUTCFullYear() > year || date.getUTCFullYear() === year && date.getUTCMonth() > month) {
          cls.push('new');
        }

        if (this.focusDate && date.valueOf() === this.focusDate.valueOf()) {
          cls.push('focused');
        } // Compare internal UTC date with local today, not UTC today


        if (this.o.todayHighlight && date.getUTCFullYear() === today.getFullYear() && date.getUTCMonth() === today.getMonth() && date.getUTCDate() === today.getDate()) {
          cls.push('today');
        }

        if (this.dates.contains(date) !== -1) {
          cls.push('active');
        }

        if (date.valueOf() < this.o.startDate || date.valueOf() > this.o.endDate || $.inArray(date.getUTCDay(), this.o.daysOfWeekDisabled) !== -1) {
          cls.push('disabled');
        }

        if (this.o.datesDisabled.length > 0 && $.grep(this.o.datesDisabled, function (d) {
          return isUTCEquals(date, d);
        }).length > 0) {
          cls.push('disabled', 'disabled-date');
        }

        if (this.range) {
          if (date > this.range[0] && date < this.range[this.range.length - 1]) {
            cls.push('range');
          }

          if ($.inArray(date.valueOf(), this.range) !== -1) {
            cls.push('selected');
          }
        }

        return cls;
      },
      fill: function fill() {
        var d = new Date(this.viewDate);
        var year = d.getUTCFullYear();
        var month = d.getUTCMonth();
        var startYear = this.o.startDate !== Number.NEGATIVE_INFINITY ? this.o.startDate.getUTCFullYear() : Number.NEGATIVE_INFINITY;
        var startMonth = this.o.startDate !== Number.NEGATIVE_INFINITY ? this.o.startDate.getUTCMonth() : Number.NEGATIVE_INFINITY;
        var endYear = this.o.endDate !== Number.POSITIVE_INFINITY ? this.o.endDate.getUTCFullYear() : Number.POSITIVE_INFINITY;
        var endMonth = this.o.endDate !== Number.POSITIVE_INFINITY ? this.o.endDate.getUTCMonth() : Number.POSITIVE_INFINITY;
        var todaytxt = dates[this.o.language].today || dates.en.today || '';
        var cleartxt = dates[this.o.language].clear || dates.en.clear || '';
        var tooltip;

        if (isNaN(year) || isNaN(month)) {
          return;
        }

        this.picker.find('.datepicker-days thead .datepicker-switch').text(dates[this.o.language].months[month] + ' ' + year);
        this.picker.find('tfoot .today').text(todaytxt).toggle(this.o.todayBtn !== false);
        this.picker.find('tfoot .clear').text(cleartxt).toggle(this.o.clearBtn !== false);
        this.updateNavArrows();
        this.fillMonths();
        var prevMonth = UTCDate(year, month - 1, 28);
        var day = DPGlobal.getDaysInMonth(prevMonth.getUTCFullYear(), prevMonth.getUTCMonth());
        prevMonth.setUTCDate(day);
        prevMonth.setUTCDate(day - (prevMonth.getUTCDay() - this.o.weekStart + 7) % 7);
        var nextMonth = new Date(prevMonth);
        nextMonth.setUTCDate(nextMonth.getUTCDate() + 42);
        nextMonth = nextMonth.valueOf();
        var html = [];
        var clsName;

        while (prevMonth.valueOf() < nextMonth) {
          if (prevMonth.getUTCDay() === this.o.weekStart) {
            html.push('<tr>');

            if (this.o.calendarWeeks) {
              // ISO 8601: First week contains first thursday.
              // ISO also states week starts on Monday, but we can be more abstract here.
              var // Start of current week: based on weekstart/current date
              ws = new Date(Number(prevMonth) + (this.o.weekStart - prevMonth.getUTCDay() - 7) % 7 * 864e5); // Thursday of this week

              var th = new Date(Number(ws) + (7 + 4 - ws.getUTCDay()) % 7 * 864e5); // First Thursday of year, year from thursday

              var yth = new Date(Number(yth = UTCDate(th.getUTCFullYear(), 0, 1)) + (7 + 4 - yth.getUTCDay()) % 7 * 864e5); // Calendar week: ms between thursdays, div ms per day, div 7 days

              var calWeek = (th - yth) / 864e5 / 7 + 1;
              html.push('<td class="cw">' + calWeek + '</td>');
            }
          }

          clsName = this.getClassNames(prevMonth);
          clsName.push('day');

          if (this.o.beforeShowDay !== $.noop) {
            var before = this.o.beforeShowDay(this._utc_to_local(prevMonth));

            if (before === undefined$1) {
              before = {};
            } else if (typeof before === 'boolean') {
              before = {
                enabled: before
              };
            } else if (typeof before === 'string') {
              before = {
                classes: before
              };
            }

            if (before.enabled === false) {
              clsName.push('disabled');
            }

            if (before.classes) {
              clsName = clsName.concat(before.classes.split(/\s+/));
            }

            if (before.tooltip) {
              tooltip = before.tooltip;
            }
          }

          clsName = $.unique(clsName);
          html.push('<td class="' + clsName.join(' ') + '"' + (tooltip ? ' title="' + tooltip + '"' : '') + '>' + prevMonth.getUTCDate() + '</td>');
          tooltip = null;

          if (prevMonth.getUTCDay() === this.o.weekEnd) {
            html.push('</tr>');
          }

          prevMonth.setUTCDate(prevMonth.getUTCDate() + 1);
        }

        this.picker.find('.datepicker-days tbody').empty().append(html.join(''));
        var months = this.picker.find('.datepicker-months').find('th:eq(1)').text(year).end().find('span').removeClass('active');
        $.each(this.dates, function (i, d) {
          if (d.getUTCFullYear() === year) {
            months.eq(d.getUTCMonth()).addClass('active');
          }
        });

        if (year < startYear || year > endYear) {
          months.addClass('disabled');
        }

        if (year === startYear) {
          months.slice(0, startMonth).addClass('disabled');
        }

        if (year === endYear) {
          months.slice(endMonth + 1).addClass('disabled');
        }

        if (this.o.beforeShowMonth !== $.noop) {
          var that = this;
          $.each(months, function (i, month) {
            if (!$(month).hasClass('disabled')) {
              var moDate = new Date(year, i, 1);

              var _before = that.o.beforeShowMonth(moDate);

              if (_before === false) {
                $(month).addClass('disabled');
              }
            }
          });
        }

        html = '';
        year = Number.parseInt(year / 10, 10) * 10;
        var yearCont = this.picker.find('.datepicker-years').find('th:eq(1)').text(year + '-' + (year + 9)).end().find('td');
        year -= 1;
        var years = $.map(this.dates, function (d) {
          return d.getUTCFullYear();
        });
        var classes;

        for (var i = -1; i < 11; i++) {
          classes = ['year'];

          if (i === -1) {
            classes.push('old');
          } else if (i === 10) {
            classes.push('new');
          }

          if ($.inArray(year, years) !== -1) {
            classes.push('active');
          }

          if (year < startYear || year > endYear) {
            classes.push('disabled');
          }

          html += '<span class="' + classes.join(' ') + '">' + year + '</span>';
          year += 1;
        }

        yearCont.html(html);
      },
      updateNavArrows: function updateNavArrows() {
        if (!this._allow_update) {
          return;
        }

        var d = new Date(this.viewDate);
        var year = d.getUTCFullYear();
        var month = d.getUTCMonth();

        switch (this.viewMode) {
          case 0:
            if (this.o.startDate !== Number.NEGATIVE_INFINITY && year <= this.o.startDate.getUTCFullYear() && month <= this.o.startDate.getUTCMonth()) {
              this.picker.find('.prev').css({
                visibility: 'hidden'
              });
            } else {
              this.picker.find('.prev').css({
                visibility: 'visible'
              });
            }

            if (this.o.endDate !== Number.POSITIVE_INFINITY && year >= this.o.endDate.getUTCFullYear() && month >= this.o.endDate.getUTCMonth()) {
              this.picker.find('.next').css({
                visibility: 'hidden'
              });
            } else {
              this.picker.find('.next').css({
                visibility: 'visible'
              });
            }

            break;

          case 1:
          case 2:
            if (this.o.startDate !== Number.NEGATIVE_INFINITY && year <= this.o.startDate.getUTCFullYear()) {
              this.picker.find('.prev').css({
                visibility: 'hidden'
              });
            } else {
              this.picker.find('.prev').css({
                visibility: 'visible'
              });
            }

            if (this.o.endDate !== Number.POSITIVE_INFINITY && year >= this.o.endDate.getUTCFullYear()) {
              this.picker.find('.next').css({
                visibility: 'hidden'
              });
            } else {
              this.picker.find('.next').css({
                visibility: 'visible'
              });
            }

            break;
        }
      },
      click: function click(e) {
        e.preventDefault();
        var target = $(e.target).closest('span, td, th');
        var year;
        var month;
        var day;

        if (target.length === 1) {
          switch (target[0].nodeName.toLowerCase()) {
            case 'th':
              switch (target[0].className) {
                case 'datepicker-switch':
                  this.showMode(1);
                  break;

                case 'prev':
                case 'next':
                  var dir = DPGlobal.modes[this.viewMode].navStep * (target[0].className === 'prev' ? -1 : 1);

                  switch (this.viewMode) {
                    case 0:
                      this.viewDate = this.moveMonth(this.viewDate, dir);

                      this._trigger('changeMonth', this.viewDate);

                      break;

                    case 1:
                    case 2:
                      this.viewDate = this.moveYear(this.viewDate, dir);

                      if (this.viewMode === 1) {
                        this._trigger('changeYear', this.viewDate);
                      }

                      break;
                  }

                  this.fill();
                  break;

                case 'today':
                  var date = new Date();
                  date = UTCDate(date.getFullYear(), date.getMonth(), date.getDate(), 0, 0, 0);
                  this.showMode(-2);
                  var which = this.o.todayBtn === 'linked' ? null : 'view';

                  this._setDate(date, which);

                  break;

                case 'clear':
                  this.clearDates();
                  break;
              }

              break;

            case 'span':
              if (!target.hasClass('disabled')) {
                this.viewDate.setUTCDate(1);

                if (target.hasClass('month')) {
                  day = 1;
                  month = target.parent().find('span').index(target);
                  year = this.viewDate.getUTCFullYear();
                  this.viewDate.setUTCMonth(month);

                  this._trigger('changeMonth', this.viewDate);

                  if (this.o.minViewMode === 1) {
                    this._setDate(UTCDate(year, month, day));
                  }
                } else {
                  day = 1;
                  month = 0;
                  year = Number.parseInt(target.text(), 10) || 0;
                  this.viewDate.setUTCFullYear(year);

                  this._trigger('changeYear', this.viewDate);

                  if (this.o.minViewMode === 2) {
                    this._setDate(UTCDate(year, month, day));
                  }
                }

                this.showMode(-1);
                this.fill();
              }

              break;

            case 'td':
              if (target.hasClass('day') && !target.hasClass('disabled')) {
                day = Number.parseInt(target.text(), 10) || 1;
                year = this.viewDate.getUTCFullYear();
                month = this.viewDate.getUTCMonth();

                if (target.hasClass('old')) {
                  if (month === 0) {
                    month = 11;
                    year -= 1;
                  } else {
                    month -= 1;
                  }
                } else if (target.hasClass('new')) {
                  if (month === 11) {
                    month = 0;
                    year += 1;
                  } else {
                    month += 1;
                  }
                }

                this._setDate(UTCDate(year, month, day));
              }

              break;
          }
        }

        if (this.picker.is(':visible') && this._focused_from) {
          $(this._focused_from).focus();
        }

        delete this._focused_from;
      },
      _toggle_multidate: function _toggle_multidate(date) {
        var ix = this.dates.contains(date);

        if (!date) {
          this.dates.clear();
        }

        if (ix !== -1) {
          if (this.o.multidate === true || this.o.multidate > 1 || this.o.toggleActive) {
            this.dates.remove(ix);
          }
        } else if (this.o.multidate === false) {
          this.dates.clear();
          this.dates.push(date);
        } else {
          this.dates.push(date);
        }

        if (typeof this.o.multidate === 'number') {
          while (this.dates.length > this.o.multidate) {
            this.dates.remove(0);
          }
        }
      },
      _setDate: function _setDate(date, which) {
        if (!which || which === 'date') {
          this._toggle_multidate(date && new Date(date));
        }

        if (!which || which === 'view') {
          this.viewDate = date && new Date(date);
        }

        this.fill();
        this.setValue();

        if (!which || which !== 'view') {
          this._trigger('changeDate');
        }

        var element;

        if (this.isInput) {
          element = this.element;
        } else if (this.component) {
          element = this.element.find('input');
        }

        if (element) {
          element.change();
        }

        if (this.o.autoclose && (!which || which === 'date')) {
          this.hide();
        }
      },
      moveMonth: function moveMonth(date, dir) {
        if (!date) {
          return;
        }

        if (!dir) {
          return date;
        }

        var new_date = new Date(date.valueOf());
        var day = new_date.getUTCDate();
        var month = new_date.getUTCMonth();
        var mag = Math.abs(dir);
        var new_month;
        var test;
        dir = dir > 0 ? 1 : -1;

        if (mag === 1) {
          test = dir === -1 ? // If going back one month, make sure month is not current month
          // (eg, Mar 31 -> Feb 31 == Feb 28, not Mar 02)
          function () {
            return new_date.getUTCMonth() === month;
          } : // If going forward one month, make sure month is as expected
          // (eg, Jan 31 -> Feb 31 == Feb 28, not Mar 02)
          function () {
            return new_date.getUTCMonth() !== new_month;
          };
          new_month = month + dir;
          new_date.setUTCMonth(new_month); // Dec -> Jan (12) or Jan -> Dec (-1) -- limit expected date to 0-11

          if (new_month < 0 || new_month > 11) {
            new_month = (new_month + 12) % 12;
          }
        } else {
          // For magnitudes >1, move one month at a time...
          for (var i = 0; i < mag; i++) // ...which might decrease the day (eg, Jan 31 to Feb 28, etc)...
          {
            new_date = this.moveMonth(new_date, dir);
          } // ...then reset the day, keeping it in the new month


          new_month = new_date.getUTCMonth();
          new_date.setUTCDate(day);

          test = function test() {
            return new_month !== new_date.getUTCMonth();
          };
        } // Common date-resetting loop -- if date is beyond end of month, make it
        // end of month


        while (test()) {
          new_date.setUTCDate(--day);
          new_date.setUTCMonth(new_month);
        }

        return new_date;
      },
      moveYear: function moveYear(date, dir) {
        return this.moveMonth(date, dir * 12);
      },
      dateWithinRange: function dateWithinRange(date) {
        return date >= this.o.startDate && date <= this.o.endDate;
      },
      keydown: function keydown(e) {
        if (!this.picker.is(':visible')) {
          if (e.keyCode === 27) // Allow escape to hide and re-show picker
            {
              this.show();
            }

          return;
        }

        var dateChanged = false;
        var dir;
        var newDate;
        var newViewDate;
        var focusDate = this.focusDate || this.viewDate;

        switch (e.keyCode) {
          case 27:
            // Escape
            if (this.focusDate) {
              this.focusDate = null;
              this.viewDate = this.dates.get(-1) || this.viewDate;
              this.fill();
            } else {
              this.hide();
            }

            e.preventDefault();
            break;

          case 37: // Left

          case 39:
            // Right
            if (!this.o.keyboardNavigation) {
              break;
            }

            dir = e.keyCode === 37 ? -1 : 1;

            if (e.ctrlKey) {
              newDate = this.moveYear(this.dates.get(-1) || UTCToday(), dir);
              newViewDate = this.moveYear(focusDate, dir);

              this._trigger('changeYear', this.viewDate);
            } else if (e.shiftKey) {
              newDate = this.moveMonth(this.dates.get(-1) || UTCToday(), dir);
              newViewDate = this.moveMonth(focusDate, dir);

              this._trigger('changeMonth', this.viewDate);
            } else {
              newDate = new Date(this.dates.get(-1) || UTCToday());
              newDate.setUTCDate(newDate.getUTCDate() + dir);
              newViewDate = new Date(focusDate);
              newViewDate.setUTCDate(focusDate.getUTCDate() + dir);
            }

            if (this.dateWithinRange(newViewDate)) {
              this.focusDate = this.viewDate = newViewDate;
              this.setValue();
              this.fill();
              e.preventDefault();
            }

            break;

          case 38: // Up

          case 40:
            // Down
            if (!this.o.keyboardNavigation) {
              break;
            }

            dir = e.keyCode === 38 ? -1 : 1;

            if (e.ctrlKey) {
              newDate = this.moveYear(this.dates.get(-1) || UTCToday(), dir);
              newViewDate = this.moveYear(focusDate, dir);

              this._trigger('changeYear', this.viewDate);
            } else if (e.shiftKey) {
              newDate = this.moveMonth(this.dates.get(-1) || UTCToday(), dir);
              newViewDate = this.moveMonth(focusDate, dir);

              this._trigger('changeMonth', this.viewDate);
            } else {
              newDate = new Date(this.dates.get(-1) || UTCToday());
              newDate.setUTCDate(newDate.getUTCDate() + dir * 7);
              newViewDate = new Date(focusDate);
              newViewDate.setUTCDate(focusDate.getUTCDate() + dir * 7);
            }

            if (this.dateWithinRange(newViewDate)) {
              this.focusDate = this.viewDate = newViewDate;
              this.setValue();
              this.fill();
              e.preventDefault();
            }

            break;

          case 32:
            // Spacebar
            // Spacebar is used in manually typing dates in some formats.
            // As such, its behavior should not be hijacked.
            break;

          case 13:
            // Enter
            focusDate = this.focusDate || this.dates.get(-1) || this.viewDate;

            if (this.o.keyboardNavigation) {
              this._toggle_multidate(focusDate);

              dateChanged = true;
            }

            this.focusDate = null;
            this.viewDate = this.dates.get(-1) || this.viewDate;
            this.setValue();
            this.fill();

            if (this.picker.is(':visible')) {
              e.preventDefault();

              if (typeof e.stopPropagation === 'function') {
                e.stopPropagation(); // All modern browsers, IE9+
              } else {
                e.cancelBubble = true; // IE6,7,8 ignore "stopPropagation"
              }

              if (this.o.autoclose) {
                this.hide();
              }
            }

            break;

          case 9:
            // Tab
            this.focusDate = null;
            this.viewDate = this.dates.get(-1) || this.viewDate;
            this.fill();
            this.hide();
            break;
        }

        if (dateChanged) {
          if (this.dates.length > 0) {
            this._trigger('changeDate');
          } else {
            this._trigger('clearDate');
          }

          var element;

          if (this.isInput) {
            element = this.element;
          } else if (this.component) {
            element = this.element.find('input');
          }

          if (element) {
            element.change();
          }
        }
      },
      showMode: function showMode(dir) {
        if (dir) {
          this.viewMode = Math.max(this.o.minViewMode, Math.min(2, this.viewMode + dir));
        }

        this.picker.children('div').hide().filter('.datepicker-' + DPGlobal.modes[this.viewMode].clsName).css('display', 'block');
        this.updateNavArrows();
      }
    };

    var DateRangePicker = function DateRangePicker(element, options) {
      this.element = $(element);
      this.inputs = $.map(options.inputs, function (i) {
        return i.jquery ? i[0] : i;
      });
      delete options.inputs;
      datepickerPlugin.call($(this.inputs), options).bind('changeDate', $.proxy(this.dateUpdated, this));
      this.pickers = $.map(this.inputs, function (i) {
        return $(i).data('datepicker');
      });
      this.updateDates();
    };

    DateRangePicker.prototype = {
      updateDates: function updateDates() {
        this.dates = $.map(this.pickers, function (i) {
          return i.getUTCDate();
        });
        this.updateRanges();
      },
      updateRanges: function updateRanges() {
        var range = $.map(this.dates, function (d) {
          return d.valueOf();
        });
        $.each(this.pickers, function (i, p) {
          p.setRange(range);
        });
      },
      dateUpdated: function dateUpdated(e) {
        // `this.updating` is a workaround for preventing infinite recursion
        // between `changeDate` triggering and `setUTCDate` calling.  Until
        // there is a better mechanism.
        if (this.updating) {
          return;
        }

        this.updating = true;
        var dp = $(e.target).data('datepicker');
        var new_date = dp.getUTCDate();
        var i = $.inArray(e.target, this.inputs);
        var j = i - 1;
        var k = i + 1;
        var l = this.inputs.length;

        if (i === -1) {
          return;
        }

        $.each(this.pickers, function (i, p) {
          if (!p.getUTCDate()) {
            p.setUTCDate(new_date);
          }
        });

        if (new_date < this.dates[j]) {
          // Date being moved earlier/left
          while (j >= 0 && new_date < this.dates[j]) {
            this.pickers[j--].setUTCDate(new_date);
          }
        } else if (new_date > this.dates[k]) {
          // Date being moved later/right
          while (k < l && new_date > this.dates[k]) {
            this.pickers[k++].setUTCDate(new_date);
          }
        }

        this.updateDates();
        delete this.updating;
      },
      remove: function remove() {
        $.map(this.pickers, function (p) {
          p.remove();
        });
        delete this.element.data().datepicker;
      }
    };

    function opts_from_el(el, prefix) {
      // Derive options from element data-attrs
      var data = $(el).data();
      var out = {};
      var inkey;
      var replace = new RegExp('^' + prefix.toLowerCase() + '([A-Z])');
      prefix = new RegExp('^' + prefix.toLowerCase());

      function re_lower(_, a) {
        return a.toLowerCase();
      }

      for (var key in data) {
        if (prefix.test(key)) {
          inkey = key.replace(replace, re_lower);
          out[inkey] = data[key];
        }
      }

      return out;
    }

    function opts_from_locale(lang) {
      // Derive options from locale plugins
      var out = {}; // Check if "de-DE" style date is available, if not language should
      // fallback to 2 letter code eg "de"

      if (!dates[lang]) {
        lang = lang.split('-')[0];

        if (!dates[lang]) {
          return;
        }
      }

      var d = dates[lang];
      $.each(locale_opts, function (i, k) {
        if (k in d) {
          out[k] = d[k];
        }
      });
      return out;
    }

    var old = $.fn.datepicker;

    var datepickerPlugin = function datepickerPlugin(option) {
      var args = Reflect.apply(Array, null, arguments);
      args.shift();
      var internal_return;
      this.each(function () {
        var $this = $(this);
        var data = $this.data('datepicker');
        var options = typeof option === 'object' && option;

        if (!data) {
          var elopts = opts_from_el(this, 'date'); // Preliminary otions

          var xopts = $.extend({}, defaults, elopts, options);
          var locopts = opts_from_locale(xopts.language); // Options priority: js args, data-attrs, locales, defaults

          var opts = $.extend({}, defaults, locopts, elopts, options);

          if ($this.hasClass('input-daterange') || opts.inputs) {
            var ropts = {
              inputs: opts.inputs || $this.find('input').toArray()
            };
            $this.data('datepicker', data = new DateRangePicker(this, $.extend(opts, ropts)));
          } else {
            $this.data('datepicker', data = new Datepicker(this, opts));
          }
        }

        if (typeof option === 'string' && typeof data[option] === 'function') {
          internal_return = data[option].apply(data, args);

          if (internal_return !== undefined$1) {
            return false;
          }
        }
      });

      if (internal_return !== undefined$1) {
        return internal_return;
      }

      return this;
    };

    $.fn.datepicker = datepickerPlugin;
    var defaults = $.fn.datepicker.defaults = {
      autoclose: false,
      beforeShowDay: $.noop,
      beforeShowMonth: $.noop,
      calendarWeeks: false,
      clearBtn: false,
      toggleActive: false,
      daysOfWeekDisabled: [],
      datesDisabled: [],
      endDate: Number.POSITIVE_INFINITY,
      forceParse: true,
      format: 'mm/dd/yyyy',
      keyboardNavigation: true,
      language: 'en',
      minViewMode: 0,
      multidate: false,
      multidateSeparator: ',',
      orientation: 'auto',
      rtl: false,
      startDate: Number.NEGATIVE_INFINITY,
      startView: 0,
      todayBtn: false,
      todayHighlight: false,
      weekStart: 0,
      disableTouchKeyboard: false,
      container: 'body'
    };
    var locale_opts = $.fn.datepicker.locale_opts = ['format', 'rtl', 'weekStart'];
    $.fn.datepicker.Constructor = Datepicker;
    var dates = $.fn.datepicker.dates = {
      en: {
        days: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'],
        daysShort: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'],
        daysMin: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa', 'Su'],
        months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
        monthsShort: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
        today: 'Today',
        clear: 'Clear'
      }
    };
    var DPGlobal = {
      modes: [{
        clsName: 'days',
        navFnc: 'Month',
        navStep: 1
      }, {
        clsName: 'months',
        navFnc: 'FullYear',
        navStep: 1
      }, {
        clsName: 'years',
        navFnc: 'FullYear',
        navStep: 10
      }],
      isLeapYear: function isLeapYear(year) {
        return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
      },
      getDaysInMonth: function getDaysInMonth(year, month) {
        return [31, DPGlobal.isLeapYear(year) ? 29 : 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
      },
      validParts: /dd?|DD?|mm?|MM?|yy(?:yy)?/g,
      nonpunctuation: /[^\t\n\r -/:-@[`{-~\u3400-\u9FFF-]+/g,
      parseFormat: function parseFormat(format) {
        // IE treats \0 as a string end in inputs (truncating the value),
        // so it's a bad format delimiter, anyway
        var separators = format.replace(this.validParts, '\0').split('\0');
        var parts = format.match(this.validParts);

        if (!separators || separators.length === 0 || !parts || parts.length === 0) {
          throw new Error('Invalid date format.');
        }

        return {
          separators: separators,
          parts: parts
        };
      },
      parseDate: function parseDate(date, format, language) {
        if (!date) {
          return;
        }

        if (date instanceof Date) {
          return date;
        }

        if (typeof format === 'string') {
          format = DPGlobal.parseFormat(format);
        }

        var part_re = /([+\-]\d+)([dmwy])/;
        var parts = date.match(/([+\-]\d+)([dmwy])/g);
        var part;
        var dir;
        var i;

        if (/^[+\-]\d+[dmwy]([\s,]+[+\-]\d+[dmwy])*$/.test(date)) {
          date = new Date();

          for (i = 0; i < parts.length; i++) {
            part = part_re.exec(parts[i]);
            dir = Number.parseInt(part[1]);

            switch (part[2]) {
              case 'd':
                date.setUTCDate(date.getUTCDate() + dir);
                break;

              case 'm':
                date = Datepicker.prototype.moveMonth.call(Datepicker.prototype, date, dir);
                break;

              case 'w':
                date.setUTCDate(date.getUTCDate() + dir * 7);
                break;

              case 'y':
                date = Datepicker.prototype.moveYear.call(Datepicker.prototype, date, dir);
                break;
            }
          }

          return UTCDate(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), 0, 0, 0);
        }

        parts = date && date.match(this.nonpunctuation) || [];
        date = new Date();
        var parsed = {};
        var setters_order = ['yyyy', 'yy', 'M', 'MM', 'm', 'mm', 'd', 'dd'];
        var setters_map = {
          yyyy: function yyyy(d, v) {
            return d.setUTCFullYear(v);
          },
          yy: function yy(d, v) {
            return d.setUTCFullYear(2000 + v);
          },
          m: function m(d, v) {
            if (isNaN(d)) {
              return d;
            }

            v -= 1;

            while (v < 0) {
              v += 12;
            }

            v %= 12;
            d.setUTCMonth(v);

            while (d.getUTCMonth() !== v) {
              d.setUTCDate(d.getUTCDate() - 1);
            }

            return d;
          },
          d: function d(_d, v) {
            return _d.setUTCDate(v);
          }
        };
        var val;
        var filtered;
        setters_map.M = setters_map.MM = setters_map.mm = setters_map.m;
        setters_map.dd = setters_map.d;
        date = UTCDate(date.getFullYear(), date.getMonth(), date.getDate(), 0, 0, 0);
        var fparts = [].concat(format.parts); // Remove noop parts

        if (parts.length !== fparts.length) {
          fparts = $(fparts).filter(function (i, p) {
            return $.inArray(p, setters_order) !== -1;
          }).toArray();
        } // Process remainder


        function match_part() {
          var m = this.slice(0, parts[i].length);
          var p = parts[i].slice(0, m.length);
          return m.toLowerCase() === p.toLowerCase();
        }

        if (parts.length === fparts.length) {
          var cnt;

          for (i = 0, cnt = fparts.length; i < cnt; i++) {
            val = Number.parseInt(parts[i], 10);
            part = fparts[i];

            if (isNaN(val)) {
              switch (part) {
                case 'MM':
                  filtered = $(dates[language].months).filter(match_part);
                  val = $.inArray(filtered[0], dates[language].months) + 1;
                  break;

                case 'M':
                  filtered = $(dates[language].monthsShort).filter(match_part);
                  val = $.inArray(filtered[0], dates[language].monthsShort) + 1;
                  break;
              }
            }

            parsed[part] = val;
          }

          var _date;

          var s;

          for (i = 0; i < setters_order.length; i++) {
            s = setters_order[i];

            if (s in parsed && !isNaN(parsed[s])) {
              _date = new Date(date);
              setters_map[s](_date, parsed[s]);

              if (!isNaN(_date)) {
                date = _date;
              }
            }
          }
        }

        return date;
      },
      formatDate: function formatDate(date, format, language) {
        if (!date) {
          return '';
        }

        if (typeof format === 'string') {
          format = DPGlobal.parseFormat(format);
        }

        var val = {
          d: date.getUTCDate(),
          D: dates[language].daysShort[date.getUTCDay()],
          DD: dates[language].days[date.getUTCDay()],
          m: date.getUTCMonth() + 1,
          M: dates[language].monthsShort[date.getUTCMonth()],
          MM: dates[language].months[date.getUTCMonth()],
          yy: date.getUTCFullYear().toString().slice(2),
          yyyy: date.getUTCFullYear()
        };
        val.dd = (val.d < 10 ? '0' : '') + val.d;
        val.mm = (val.m < 10 ? '0' : '') + val.m;
        date = [];
        var seps = $.extend([], format.separators);

        for (var i = 0, cnt = format.parts.length; i <= cnt; i++) {
          if (seps.length > 0) {
            date.push(seps.shift());
          }

          date.push(val[format.parts[i]]);
        }

        return date.join('');
      },
      headTemplate: '<thead>' + '<tr>' + '<th class="prev">&#171;</th>' + '<th colspan="5" class="datepicker-switch"></th>' + '<th class="next">&#187;</th>' + '</tr>' + '</thead>',
      contTemplate: '<tbody><tr><td colspan="7"></td></tr></tbody>',
      footTemplate: '<tfoot>' + '<tr>' + '<th colspan="7" class="today"></th>' + '</tr>' + '<tr>' + '<th colspan="7" class="clear"></th>' + '</tr>' + '</tfoot>'
    };
    DPGlobal.template = '<div class="datepicker">' + '<div class="datepicker-days">' + '<table class=" table-condensed">' + DPGlobal.headTemplate + '<tbody></tbody>' + DPGlobal.footTemplate + '</table>' + '</div>' + '<div class="datepicker-months">' + '<table class="table-condensed">' + DPGlobal.headTemplate + DPGlobal.contTemplate + DPGlobal.footTemplate + '</table>' + '</div>' + '<div class="datepicker-years">' + '<table class="table-condensed">' + DPGlobal.headTemplate + DPGlobal.contTemplate + DPGlobal.footTemplate + '</table>' + '</div>' + '</div>';
    $.fn.datepicker.DPGlobal = DPGlobal;
    /* DATEPICKER NO CONFLICT
    * =================== */

    $.fn.datepicker.noConflict = function () {
      $.fn.datepicker = old;
      return this;
    };
    /* DATEPICKER DATA-API
    * ================== */


    $(document).on('focus.datepicker.data-api click.datepicker.data-api', '[data-provide="datepicker"]', function (e) {
      var $this = $(this);

      if ($this.data('datepicker')) {
        return;
      }

      e.preventDefault(); // Component click requires us to explicitly show it

      datepickerPlugin.call($this, 'show');
    });
    $(function () {
      datepickerPlugin.call($('[data-provide="datepicker-inline"]'));
    });
  })(window.jQuery);

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME$4 = 'enter';
  var DATA_KEY$4 = 'bs.enter';
  var EVENT_KEY$4 = "." + DATA_KEY$4;
  var DATA_API_KEY$4 = '.data-api';
  var Default$3 = {
    easing: 'cubic-bezier(.2, .7, .5, 1)',
    duration: 1200,
    delay: 0
  };
  var DefaultType$3 = {
    easing: 'string',
    duration: 'number',
    delay: 'number'
  };
  var EVENT_SCROLL$1 = "scroll" + EVENT_KEY$4;
  var EVENT_ENTER = "enter" + EVENT_KEY$4;
  var EVENT_LOAD_DATA_API$3 = "load" + EVENT_KEY$4 + DATA_API_KEY$4;
  var SELECTOR_DATA_TRANSITION = '[data-bs-transition="entrance"]';
  /**
   * ------------------------------------------------------------------------
   * Class Definition
   * ------------------------------------------------------------------------
   */

  var Enter = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(Enter, _BaseComponent);

    function Enter(element, config) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;
      _this._handler = null;
      _this._config = _this._getConfig(config);

      _this._addEventListeners();

      return _this;
    } // Getters


    var _proto = Enter.prototype;

    // Public
    _proto.dispose = function dispose() {
      this._element = null;
      this._config = null;
      this._handler = null;

      _BaseComponent.prototype.dispose.call(this);
    } // Private
    ;

    _proto._getConfig = function _getConfig(config) {
      config = _extends({}, Default$3, config);
      util.typeCheckConfig(NAME$4, config, DefaultType$3);
      return config;
    };

    _proto._addEventListeners = function _addEventListeners() {
      var boundScrollHandler = this._checkForEnter.bind(this);

      this._handler = function () {
        window.requestAnimationFrame(boundScrollHandler);
      };

      EventHandler__default['default'].on(window, EVENT_SCROLL$1, this._handler);

      this._checkForEnter();
    };

    _proto._removeEventListeners = function _removeEventListeners() {
      EventHandler__default['default'].off(window, EVENT_SCROLL$1, this._handler);
    };

    _proto._checkForEnter = function _checkForEnter() {
      var windowHeight = window.innerHeight;

      var rect = this._element.getBoundingClientRect();

      if (windowHeight - rect.top >= 0) {
        setTimeout(this._triggerEntrance.bind(this), this._config.delay);
      }
    };

    _proto._triggerEntrance = function _triggerEntrance() {
      this._removeEventListeners();

      this._element.style.transition = "transform " + this._config.duration + "ms " + this._config.easing;
      this._element.style.transform = 'none';
      this._element.style['-webkit-transition'] = "-webkit-" + this._element.style.transition;
      this._element.style['-webkit-transform'] = this._element.style.transform;
      this._element.style['-ms-transition'] = "-ms-" + this._element.style.transition;
      this._element.style['-ms-transform'] = this._element.style.transform;
      EventHandler__default['default'].trigger(this._element, EVENT_ENTER);
    } // Static
    ;

    Enter.enterInterface = function enterInterface(element, config) {
      var data = Data__default['default'].get(element, DATA_KEY$4);

      var _config = _extends({}, Default$3, Manipulator__default['default'].getDataAttributes(element));

      if (typeof config === 'object') {
        _config = _extends({}, _config, config);
      }

      if (!data) {
        data = new Enter(element, _config);
      }

      if (typeof config === 'string') {
        data[config]();
      }
    };

    Enter.jQueryInterface = function jQueryInterface(config) {
      var _this2 = this;

      return this.each(function () {
        Enter.enterInterface(_this2, config);
      });
    };

    _createClass(Enter, null, [{
      key: "Default",
      get: function get() {
        return Default$3;
      }
    }, {
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY$4;
      }
    }]);

    return Enter;
  }(BaseComponent__default['default']);
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(window, EVENT_LOAD_DATA_API$3, function () {
    var enters = SelectorEngine__default['default'].find(SELECTOR_DATA_TRANSITION);

    for (var i = 0, len = enters.length; i < len; i++) {
      Enter.enterInterface(enters[i], Data__default['default'].get(enters[i], DATA_KEY$4));
    }
  });
  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   * add .Enter to jQuery only if jQuery is present
   */

  util.defineJQueryPlugin(NAME$4, Enter);

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME$3 = 'imageGrid';
  var DATA_KEY$3 = 'bs.image-grid';
  var EVENT_KEY$3 = "." + DATA_KEY$3;
  var DATA_API_KEY$3 = '.data-api';
  var Default$2 = {
    padding: 10,
    targetHeight: 300,
    display: 'inline-block'
  };
  var DefaultType$2 = {
    padding: 'number',
    targetHeight: 'number',
    display: 'string'
  };
  var EVENT_RESIZE = "resize" + EVENT_KEY$3;
  var EVENT_LOAD_DATA_API$2 = "load" + EVENT_KEY$3 + DATA_API_KEY$3;
  var SELECTOR_GRID = '[data-bs-grid="images"]';
  /**
   * ------------------------------------------------------------------------
   * Class Definition
   * ------------------------------------------------------------------------
   */

  var ImageGrid = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(ImageGrid, _BaseComponent);

    function ImageGrid(element, config) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;

      _this._cleanWhitespace(element);

      _this._row = 0;
      _this._rownum = 1;
      _this._elements = [];
      _this._albumWidth = element.scrollWidth;
      _this._images = SelectorEngine__default['default'].children(element);
      _this._config = _this._getConfig(config);

      _this._addEventListeners();

      _this._processImages();

      return _this;
    } // Getters


    var _proto = ImageGrid.prototype;

    // Public
    _proto.dispose = function dispose() {
      EventHandler__default['default'].off(window, EVENT_KEY$3);
      this._row = null;
      this._rownum = null;
      this._elements = null;
      this._albumWidth = null;
      this._images = null;
      this._config = null;

      _BaseComponent.prototype.dispose.call(this);
    } // Private
    ;

    _proto._getConfig = function _getConfig(config) {
      config = _extends({}, Default$2, config);
      util.typeCheckConfig(NAME$3, config, DefaultType$2);
      return config;
    };

    _proto._handleResize = function _handleResize() {
      this._row = 0;
      this._rownum = 1;
      this._elements = [];
      this._albumWidth = this._element.scrollWidth;
      this._images = SelectorEngine__default['default'].children();

      this._processImages();
    };

    _proto._addEventListeners = function _addEventListeners() {
      EventHandler__default['default'].on(window, EVENT_RESIZE, this._handleResize.bind(this));
    };

    _proto._processImages = function _processImages() {
      var _this2 = this;

      this._images.each(function (index) {
        var img = _this2.tagName === 'IMG' ? _this2 : SelectorEngine__default['default'].find('img', _this2);
        var w = typeof img.dataset.width === 'undefined' ? img.scrollWidth : img.dataset.width;
        var h = typeof img.dataset.height === 'undefined' ? img.scrollHeight : img.dataset.height;
        img.dataset.width = w;
        img.dataset.height = h;
        var idealW = Math.ceil(w / h * _this2._config.targetHeight);
        var idealH = Math.ceil(_this2._config.targetHeight);

        _this2._elements.push([_this2, idealW, idealH]);

        _this2._row += idealW + _this2._config.padding;

        if (_this2._row > _this2._albumWidth && _this2._elements.length > 0) {
          _this2._resizeRow(_this2._row - _this2._config.padding);

          _this2._row = 0;
          _this2._elements = [];
          _this2._rownum += 1;
        }

        if (_this2._images.length - 1 === index && _this2._elements.length > 0) {
          _this2._resizeRow(_this2._row);

          _this2._row = 0;
          _this2._elements = [];
          _this2._rownum += 1;
        }
      });
    };

    _proto._resizeRow = function _resizeRow(row) {
      var imageExtras = this._config.padding * (this._elements.length - 1);
      var albumWidthAdjusted = this._albumWidth - imageExtras;
      var overPercent = albumWidthAdjusted / (row - imageExtras);
      var trackWidth = imageExtras;

      for (var i = 0; i < this._elements.length; i++) {
        var obj = this._elements[i][0];
        var fw = Math.floor(this._elements[i][1] * overPercent);
        var fh = Math.floor(this._elements[i][2] * overPercent);
        var isNotLast = i < this._elements.length - 1;
        trackWidth += fw;

        if (!isNotLast && trackWidth < this._albumWidth) {
          fw += this._albumWidth - trackWidth;
        }

        fw--;
        var img = obj.tagName === 'IMG' ? obj : SelectorEngine__default['default'].find('img', obj);
        img.style.width = fw;
        img.style.height = fh;

        this._applyModifications(obj, isNotLast);
      }
    };

    _proto._applyModifications = function _applyModifications(obj, isNotLast) {
      var css = {
        marginBottom: this._config.padding + 'px',
        marginRight: isNotLast ? this._config.padding + 'px' : 0,
        display: this._config.display,
        verticalAlign: 'bottom'
      };
      obj.style.marginBottom = css.marginBottom;
      obj.style.marginRight = css.marginRight;
      obj.display = css.display;
      obj.verticalAlign = css.verticalAlign;
    };

    _proto._cleanWhitespace = function _cleanWhitespace(element) {
      var _this3 = this;

      [].concat(element).filter(function () {
        return _this3.nodeType === 3 && !/\S/.test(_this3.nodeValue);
      }).remove();
    } // Static
    ;

    ImageGrid.imageGridInterface = function imageGridInterface(element, config) {
      var data = Data__default['default'].get(element, DATA_KEY$3);

      var _config = _extends({}, Default$2, Manipulator__default['default'].getDataAttributes(element));

      if (typeof config === 'object') {
        _config = _extends({}, _config, config);
      }

      if (!data) {
        data = new ImageGrid(element, _config);
      }

      if (typeof config === 'string') {
        if (typeof data[config] === 'undefined') {
          throw new TypeError("No method named \"" + config + "\"");
        }

        data[config]();
      }
    };

    ImageGrid.jQueryInterface = function jQueryInterface(config) {
      var _this4 = this;

      return this.each(function () {
        ImageGrid.imageGridInterface(_this4, config);
      });
    };

    _createClass(ImageGrid, null, [{
      key: "Default",
      get: function get() {
        return Default$2;
      }
    }, {
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY$3;
      }
    }]);

    return ImageGrid;
  }(BaseComponent__default['default']);
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(window, EVENT_LOAD_DATA_API$2, function () {
    var imageGrids = SelectorEngine__default['default'].find(SELECTOR_GRID);

    for (var i = 0, len = imageGrids.length; i < len; i++) {
      ImageGrid.carouselInterface(imageGrids[i], Data__default['default'].get(imageGrids[i], DATA_KEY$3));
    }
  });
  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   * add .ImageGrid to jQuery only if jQuery is present
   */

  util.defineJQueryPlugin(NAME$3, ImageGrid);

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME$2 = 'navbar';
  var DATA_KEY$2 = 'bs.navbar';
  var EVENT_KEY$2 = "." + DATA_KEY$2;
  var DATA_API_KEY$2 = '.data-api';
  var COLLAPSE_DATA_KEY = Collapse__default['default'].DATA_KEY;
  var COLLAPSE_EVENT_KEY = "." + COLLAPSE_DATA_KEY;
  var Default$1 = {
    scrollTop: false
  };
  var DefaultType$1 = {
    scrollTop: 'boolean'
  };
  var EVENT_OPEN$1 = "open" + EVENT_KEY$2;
  var EVENT_OPENED$1 = "opened" + EVENT_KEY$2;
  var EVENT_CLOSE$1 = "close" + EVENT_KEY$2;
  var EVENT_CLOSED$1 = "closed" + EVENT_KEY$2;
  var EVENT_LOAD_DATA_API$1 = "load" + EVENT_KEY$2 + DATA_API_KEY$2;
  var COLLAPSE_EVENT_SHOW = "show" + COLLAPSE_EVENT_KEY;
  var COLLAPSE_EVENT_SHOWN = "shown" + COLLAPSE_EVENT_KEY;
  var COLLAPSE_EVENT_HIDE = "hide" + COLLAPSE_EVENT_KEY;
  var COLLAPSE_EVENT_HIDDEN = "hidden" + COLLAPSE_EVENT_KEY;
  var CLASS_NAME_OPENING = 'opening';
  var CLASS_NAME_OPEN = 'open';
  var CLASS_NAME_CLOSING = 'closing';
  var SELECTOR_NAVBAR = '.navbar';
  var SELECTOR_NAVBAR_COLLAPSE = '.navbar-collapse';
  /**
   * ------------------------------------------------------------------------
   * Class Definition
   * ------------------------------------------------------------------------
   */

  var Navbar = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(Navbar, _BaseComponent);

    function Navbar(element, config) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;
      _this._html = document.documentElement;
      _this._collapseNavbarElement = SelectorEngine__default['default'].find(SELECTOR_NAVBAR_COLLAPSE, _this._element);
      _this._config = _this._getConfig(config);

      _this._addEventListeners();

      console.info('Successfully constructed navbar.');
      console.debug(_this._config);
      console.debug(_this._element);
      return _this;
    } // Getters


    var _proto = Navbar.prototype;

    // Public
    _proto.open = function open() {
      Collapse__default['default'].collapseInterface(this._collapseNavbarElement, 'show');
    };

    _proto.close = function close() {
      Collapse__default['default'].collapseInterface(this._collapseNavbarElement, 'hide');
    } // Private
    ;

    _proto._getConfig = function _getConfig(config) {
      config = _extends({}, Default$1, config);
      config.scrollTop = Boolean(config.scrollTop);
      util.typeCheckConfig(NAME$2, config, DefaultType$1);
      return config;
    };

    _proto._addEventListeners = function _addEventListeners() {
      EventHandler__default['default'].on(this._collapseNavbarElement, COLLAPSE_EVENT_SHOW, this._onShowNavbarCollapse.bind(this));
      EventHandler__default['default'].on(this._collapseNavbarElement, COLLAPSE_EVENT_SHOWN, this._onShownNavbarCollapse.bind(this));
      EventHandler__default['default'].on(this._collapseNavbarElement, COLLAPSE_EVENT_HIDE, this._onHideNavbarCollapse.bind(this));
      EventHandler__default['default'].on(this._collapseNavbarElement, COLLAPSE_EVENT_HIDDEN, this._onHiddenNavbarCollapse.bind(this));
    };

    _proto._onShowNavbarCollapse = function _onShowNavbarCollapse() {
      if (this._config.scrollTop) {
        this._html.scrollTop(Math.ceil(this._element.offsetTop));
      }

      EventHandler__default['default'].trigger(this._element, EVENT_OPEN$1);

      this._element.classList.add(CLASS_NAME_OPENING);
    };

    _proto._onShownNavbarCollapse = function _onShownNavbarCollapse() {
      this.element.classList.add(CLASS_NAME_OPEN);
      this.element.classList.remove(CLASS_NAME_OPENING);
      EventHandler__default['default'].trigger(this._element, EVENT_OPENED$1);
    };

    _proto._onHideNavbarCollapse = function _onHideNavbarCollapse() {
      EventHandler__default['default'].trigger(this._element, EVENT_CLOSE$1);

      this._element.classList.add(CLASS_NAME_CLOSING);

      this._element.classList.remove(CLASS_NAME_OPEN);
    };

    _proto._onHiddenNavbarCollapse = function _onHiddenNavbarCollapse() {
      this._element.classList.remove(CLASS_NAME_CLOSING);

      EventHandler__default['default'].trigger(EVENT_CLOSED$1);
    } // Static
    ;

    Navbar.navbarInterface = function navbarInterface(element, config) {
      var data = Data__default['default'].get(element, DATA_KEY$2);

      var _config = _extends({}, Default$1, Manipulator__default['default'].getDataAttributes(element));

      if (typeof config === 'object') {
        _config = _extends({}, _config, config);
      }

      if (!data) {
        data = new Navbar(element, _config);
      }

      if (typeof config === 'string') {
        if (typeof data[config] === 'undefined') {
          throw new TypeError("No method named \"" + config + "\"");
        }

        data[config]();
      }
    };

    Navbar.jQueryInterface = function jQueryInterface(config) {
      return this.each(function () {
        Navbar.navbarInterface(this, config);
      });
    };

    _createClass(Navbar, null, [{
      key: "Default",
      get: function get() {
        return Default$1;
      }
    }, {
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY$2;
      }
    }]);

    return Navbar;
  }(BaseComponent__default['default']);
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(window, EVENT_LOAD_DATA_API$1, function () {
    var navbars = SelectorEngine__default['default'].find(SELECTOR_NAVBAR);

    for (var i = 0, len = navbars.length; i < len; i++) {
      Navbar.navbarInterface(navbars[i], Data__default['default'].get(navbars[i], DATA_KEY$2));
    }
  });

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME$1 = 'stage';
  var DATA_KEY$1 = 'bs.stage';
  var EVENT_KEY$1 = "." + DATA_KEY$1;
  var DATA_API_KEY$1 = '.data-api';
  var TRANSITION_END$1 = 'transitionend';
  var Default = {
    easing: 'cubic-bezier(.2, .7, .5, 1)',
    duration: 300,
    delay: 0,
    distance: 250,
    hiddenElements: '#sidebar'
  };
  var DefaultType = {
    easing: 'string',
    duration: 'number',
    delay: 'number',
    distance: 'number',
    hiddenElements: 'string'
  };
  var EVENT_TOUCHMOVE$1 = "touchmove" + EVENT_KEY$1;
  var EVENT_KEYDOWN = "keydown" + EVENT_KEY$1;
  var EVENT_OPEN = "open" + EVENT_KEY$1;
  var EVENT_OPENED = "opened" + EVENT_KEY$1;
  var EVENT_CLOSE = "close" + EVENT_KEY$1;
  var EVENT_CLOSED = "closed" + EVENT_KEY$1;
  var EVENT_CLICK$1 = "click" + EVENT_KEY$1;
  var EVENT_CLICK_DATA_API = "click" + EVENT_KEY$1 + DATA_API_KEY$1;
  var CLASS_NAME_STAGE_OPEN = 'stage-open';
  var CLASS_NAME_HIDDEN = 'hidden';
  var SELECTOR_TOGGLE = '[data-toggle="stage"]';
  /**
     * ------------------------------------------------------------------------
     * Class Definition
     * ------------------------------------------------------------------------
     */

  var Stage = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(Stage, _BaseComponent);

    function Stage(element, config) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;
      _this._config = _this._getConfig(config);
      return _this;
    } // Getters


    var _proto = Stage.prototype;

    // Private
    _proto._getConfig = function _getConfig(config) {
      config = _extends({}, Default, config);
      util.typeCheckConfig(NAME$1, config, DefaultType);
      return config;
    };

    _proto._isOpen = function _isOpen() {
      return this._element.classList.contains(CLASS_NAME_STAGE_OPEN);
    };

    _proto._complete = function _complete() {
      document.body.style.overflow = 'auto';

      if ('ontouchstart' in document.documentElement) {
        EventHandler__default['default'].off(document, EVENT_TOUCHMOVE$1);
      }

      this._config.hiddenElements.classList.add(CLASS_NAME_HIDDEN);

      this._element.classList.remove(CLASS_NAME_STAGE_OPEN);

      this._element.style.transition = '';
      this._element.style.transform = '';
      this._element.style['-webkit-transition'] = this._element.style.transition;
      this._element.style['-webkit-transform'] = this._element.style.transform;
      this._element.style['-ms-transition'] = this._element.style.transition;
      this._element.style['-ms-transform'] = this._element.style.transform;
      EventHandler__default['default'].trigger(this._element, EVENT_CLOSED);
    } // Public
    ;

    _proto.toggle = function toggle() {
      if (this._isOpen()) {
        this.close();
      } else {
        this.open();
      }
    };

    _proto.open = function open() {
      var _this2 = this;

      document.body.style.overflow = 'hidden';

      if ('ontouchstart' in document.documentElement) {
        EventHandler__default['default'].on(document, EVENT_TOUCHMOVE$1, function (event) {
          event.preventDefault();
        });
      }

      this._config.hiddenElements.classList.remove(CLASS_NAME_HIDDEN);

      EventHandler__default['default'].one(window, EVENT_KEYDOWN, function (event) {
        event.which = _this2.close();
      });
      EventHandler__default['default'].on(this._element, EVENT_CLICK$1, this.close.bind(this));
      EventHandler__default['default'].trigger(this._element, EVENT_OPEN);

      this._element.classList.add(CLASS_NAME_STAGE_OPEN);

      this._element.style.transition = "transform " + this._config.duration + "ms " + this._config.easing;
      this._element.style['-webkit-transition'] = "-webkit-" + this._element.style.transition;
      this._element.style['-ms-transition'] = "-ms-" + this._element.style.transition; // eslint-disable-next-line no-unused-expressions

      this._element.scrollWidth; // Force reflow

      this._element.style.transform = "translateX(" + this._config.distance + "px)";
      this._element.style['-webkit-transform'] = "-webkit-" + this._element.style.transform;
      this._element.style['-ms-transform'] = "-ms-" + this._element.style.transform;
      EventHandler__default['default'].one(this._element, TRANSITION_END$1, function () {
        EventHandler__default['default'].trigger(_this2._element, EVENT_OPENED);
      });
      EventHandler__default['default'].emulateTransitionEnd(this._element, this._config.duration);
    };

    _proto.close = function close() {
      EventHandler__default['default'].off(window, EVENT_KEYDOWN);
      EventHandler__default['default'].trigger(this._element, EVENT_CLOSE);
      EventHandler__default['default'].off(this._element, EVENT_CLICK$1);
      this._element.style.transform = 'none';
      this._element.style['-webkit-transform'] = this._element.style.transform;
      this._element.style['-ms-transform'] = this._element.style.transform;
      EventHandler__default['default'].one(this._element, TRANSITION_END$1, this._complete.bind(this));
      EventHandler__default['default'].emulateTransitionEnd(this._element, this._config.duration);
    } // Static
    ;

    Stage.stageInterface = function stageInterface(element, config) {
      var data = Data__default['default'].get(element, DATA_KEY$1);

      var _config = _extends({}, Default, Manipulator__default['default'].getDataAttributes(element));

      if (typeof config === 'object') {
        _config = _extends({}, _config, config);
      }

      if (!data) {
        data = new Stage(element, _config);
      }

      if (typeof config === 'string') {
        if (typeof data[config] === 'undefined') {
          throw new TypeError("No method named \"" + config + "\"");
        }

        data[config]();
      }
    };

    Stage.jQueryInterface = function jQueryInterface(config) {
      return this.each(function () {
        Stage.stageInterface(this, config);
      });
    };

    Stage.dataApiClickHandler = function dataApiClickHandler() {
      var target = util.getElementFromSelector(this);

      if (!target) {
        return;
      }

      Stage.stageInterface(target, 'toggle');
    };

    _createClass(Stage, null, [{
      key: "Default",
      get: function get() {
        return Default;
      }
    }, {
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY$1;
      }
    }]);

    return Stage;
  }(BaseComponent__default['default']);
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(document, EVENT_CLICK_DATA_API, SELECTOR_TOGGLE, Stage.dataApiClickHandler);
  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   * add .Carousel to jQuery only if jQuery is present
   */

  util.defineJQueryPlugin(NAME$1, Stage);

  /**
   * ------------------------------------------------------------------------
   * Constants
   * ------------------------------------------------------------------------
   */

  var NAME = 'zoom';
  var DATA_KEY = 'bs.zoom';
  var EVENT_KEY = "." + DATA_KEY;
  var DATA_API_KEY = '.data-api';
  var TRANSITION_END = 'transitionend';
  var ZOOM_OFFSET = 80;
  var EVENT_CLICK = "click" + EVENT_KEY;
  var EVENT_SCROLL = "scroll" + EVENT_KEY;
  var EVENT_KEYUP = "keyup" + EVENT_KEY;
  var EVENT_TOUCHSTART = "touchstart" + EVENT_KEY;
  var EVENT_TOUCHMOVE = "touchmove" + EVENT_KEY;
  var EVENT_LOAD_DATA_API = "load" + EVENT_KEY + DATA_API_KEY;
  var CLASS_NAME_ZOOM_OVERLAY_OPEN = 'zoom-overlay-open';
  var CLASS_NAME_ZOOM_OVERLAY_TRANSITIONING = 'zoom-overlay-transitioning';
  var CLASS_NAME_ZOOM_OVERLAY = 'zoom-overlay';
  var CLASS_NAME_ZOOM_IMG_WRAP = 'zoom-img-wrap';
  var CLASS_NAME_ZOOM_IMG = 'zoom-img';
  var SELECTOR_ACTION = '[data-action="zoom"]';
  var DATA_ZOOM = 'zoom';
  var DATA_ZOOM_OUT = 'zoom-out';
  /**
   * ------------------------------------------------------------------------
   * Class Definition
   * ------------------------------------------------------------------------
   */

  var ZoomService = /*#__PURE__*/function (_BaseComponent) {
    _inheritsLoose(ZoomService, _BaseComponent);

    function ZoomService(element) {
      var _this;

      _this = _BaseComponent.call(this, element) || this;
      _this._activeZoom = null;
      _this._initialScrollPosition = null;
      _this._initialTouchPosition = null;
      _this._touchMoveListener = null;
      _this._document = document;
      _this._window = window;
      _this._body = document.body;
      _this._boundClick = _this._clickHandler.bind(_assertThisInitialized(_this));
      return _this;
    } // Getters


    var _proto = ZoomService.prototype;

    // Private
    _proto._zoom = function _zoom(event) {
      var target = event.target,
          ctrlKey = event.ctrlKey,
          metaKey = event.metaKey,
          bubbles = event.bubbles;

      if (!target || target.tagName !== 'IMG') {
        return;
      }

      if (this._body.classList.contains(CLASS_NAME_ZOOM_OVERLAY_OPEN)) {
        return;
      }

      if (metaKey || ctrlKey) {
        return window.open(target.getAttribute('data-original') || target.src, '_blank');
      }

      if (target.width >= window.scrollWidth() - ZOOM_OFFSET) {
        return;
      }

      this._activeZoomClose(true);

      this._activeZoom = new Zoom(target);

      this._activeZoom.zoomImage(); // Todo: Probably worth throttling this


      EventHandler__default['default'].on(this._window, EVENT_SCROLL, this._scrollHandler.bind(this));
      EventHandler__default['default'].on(this._document, EVENT_KEYUP, this._keyHandler.bind(this));
      EventHandler__default['default'].on(this._document, EVENT_TOUCHSTART, this._touchStart.bind(this)); // We use a capturing phase here to prevent unintended js events

      if (document.addEventListener) {
        document.addEventListener('click', this._boundClick, true);
      } else {
        document.attachEvent('onclick', this._boundClick, true);
      }

      if ('bubbles' in event) {
        if (bubbles) {
          event.stopPropagation();
        }
      } else {
        // Internet Explorer before version 9
        event.cancelBubble = true;
      }
    };

    _proto._activeZoomClose = function _activeZoomClose(forceDispose) {
      if (!this._activeZoom) {
        return;
      }

      if (forceDispose) {
        this._activeZoom.dispose();
      } else {
        this._activeZoom.close();
      }

      EventHandler__default['default'].off(this._window, EVENT_KEY);
      EventHandler__default['default'].off(this._window, EVENT_KEY);
      document.removeEventListener('click', this._boundClick, true);
      this._activeZoom = null;
    };

    _proto._scrollHandler = function _scrollHandler() {
      if (this._initialScrollPosition === null) {
        this._initialScrollPosition = window.scrollTop;
      }

      var deltaY = this._initialScrollPosition - window.scrollTop;

      if (Math.abs(deltaY) >= 40) {
        this._activeZoomClose();
      }
    };

    _proto._keyHandler = function _keyHandler(event) {
      if (event.keyCode === 27) {
        this._activeZoomClose();
      }
    };

    _proto._clickHandler = function _clickHandler(event) {
      if (event.preventDefault) {
        event.preventDefault();
      } else {
        event.returnValue = false;
      }

      if ('bubbles' in event) {
        if (event.bubbles) {
          event.stopPropagation();
        }
      } else {
        // Internet Explorer before version 9
        event.cancelBubble = true;
      }

      this._activeZoomClose();
    };

    _proto._touchStart = function _touchStart(event) {
      this._initialTouchPosition = event.touches[0].pageY;
      EventHandler__default['default'].on(event.target, EVENT_TOUCHMOVE, this._touchMove.bind(this));
    };

    _proto._touchMove = function _touchMove(event) {
      if (Math.abs(event.touches[0].pageY - this._initialTouchPosition) > 10) {
        this._activeZoomClose();

        EventHandler__default['default'].off(event.target, EVENT_TOUCHMOVE);
      }
    };

    _proto.listen = function listen() {
      EventHandler__default['default'].on(this._body, EVENT_CLICK, SELECTOR_ACTION, this._zoom.bind(this));
    };

    _createClass(ZoomService, null, [{
      key: "DATA_KEY",
      get: function get() {
        return DATA_KEY;
      }
    }]);

    return ZoomService;
  }(BaseComponent__default['default']);

  var Zoom = /*#__PURE__*/function () {
    function Zoom(element) {
      this._fullHeight = null;
      this._fullWidth = null;
      this._overlay = null;
      this._targetImageWrap = null;
      this._targetImage = element;
      this._body = document.body;
    } // Public


    var _proto2 = Zoom.prototype;

    _proto2.zoomImage = function zoomImage() {
      var _this2 = this;

      var img = document.createElement('img');
      img.addEventListener('load', function () {
        _this2._fullHeight = Number(img.height);
        _this2._fullWidth = Number(img.width);

        _this2._zoomOriginal();
      });
      img.src = this._targetImage.src;
    };

    _proto2._zoomOriginal = function _zoomOriginal() {
      this._targetImageWrap = document.createElement('div');
      this._targetImageWrap.className = CLASS_NAME_ZOOM_IMG_WRAP;

      this._targetImage.parentNode.insertBefore(this._targetImageWrap, this._targetImage);

      this._targetImageWrap.append(this._targetImage);

      this._targetImage.classList.add(CLASS_NAME_ZOOM_IMG);

      this._targetImage.dataset.Action = DATA_ZOOM_OUT;
      this._overlay = document.createElement('div');
      this._overlay.className = CLASS_NAME_ZOOM_OVERLAY;
      document.body.append(this._overlay);

      this._calculateZoom();

      this._triggerAnimation();
    };

    _proto2._calculateZoom = function _calculateZoom() {
      // eslint-disable-next-line no-unused-expressions
      this._targetImage.scrollWidth; // Repaint before animating

      var originalFullImageWidth = this._fullWidth;
      var originalFullImageHeight = this._fullHeight;
      var maxScaleFactor = originalFullImageWidth / this._targetImage.width;
      var viewportHeight = window.scrollHeight - ZOOM_OFFSET;
      var viewportWidth = window.scrollWidth - ZOOM_OFFSET;
      var imageAspectRatio = originalFullImageWidth / originalFullImageHeight;
      var viewportAspectRatio = viewportWidth / viewportHeight;

      if (originalFullImageWidth < viewportWidth && originalFullImageHeight < viewportHeight) {
        this._imgScaleFactor = maxScaleFactor;
      } else if (imageAspectRatio < viewportAspectRatio) {
        this._imgScaleFactor = viewportHeight / originalFullImageHeight * maxScaleFactor;
      } else {
        this._imgScaleFactor = viewportWidth / originalFullImageWidth * maxScaleFactor;
      }
    };

    _proto2._triggerAnimation = function _triggerAnimation() {
      // eslint-disable-next-line no-unused-expressions
      this._targetImage.scrollWidth; // Repaint before animating

      var imageOffset = {
        top: this._targetImage.offsetTop,
        left: this._targetImage.offsetLeft
      };
      var _window = window,
          scrollTop = _window.scrollTop,
          scrollHeight = _window.scrollHeight,
          scrollWidth = _window.scrollWidth;
      var viewportY = scrollTop + scrollHeight / 2;
      var viewportX = scrollWidth / 2;
      var imageCenterY = imageOffset.top + this._targetImage.height / 2;
      var imageCenterX = imageOffset.left + this._targetImage.width / 2;
      this._translateY = viewportY - imageCenterY;
      this._translateX = viewportX - imageCenterX;
      var targetTransform = "scale(" + this._imgScaleFactor + ")";
      var imageWrapTransform = "translate(" + this._translateX + "px, " + this._translateY + "px)";
      this._targetImage.style.transform = targetTransform;
      this._targetImage.style['-webkit-transform'] = this._targetImage.style.transform;
      this._targetImage.style['-ms-transform'] = this._targetImage.style.transform;
      this._targetImageWrap.style.transform = imageWrapTransform;
      this._targetImageWrap.style['-webkit-transform'] = this._targetImageWrap.style.transform;
      this._targetImageWrap.style['-ms-transform'] = this._targetImageWrap.style.transform;

      this._body.classList.add(CLASS_NAME_ZOOM_OVERLAY_OPEN);
    };

    _proto2.close = function close() {
      this._body.classList.remove(CLASS_NAME_ZOOM_OVERLAY_OPEN);

      this._body.classList.add(CLASS_NAME_ZOOM_OVERLAY_TRANSITIONING);

      this._targetImage.transform = '';
      this._targetImage['-webkit-transform'] = this._targetImage.transform;
      this._targetImage['-ms-transform'] = this._targetImage.transform;
      this._targetImageWrap.transform = '';
      this._targetImageWrap['-webkit-transform'] = this._targetImageWrap.transform;
      this._targetImageWrap['-ms-transform'] = this._targetImageWrap.transform;
      EventHandler__default['default'].one(TRANSITION_END, this.dispose.bind(this));
      EventHandler__default['default'].emulateTransitionEnd(300);
    };

    _proto2.dispose = function dispose() {
      if (this._targetImageWrap && this._targetImageWrap.parentNode) {
        this._targetImage.classList.remove(CLASS_NAME_ZOOM_IMG);

        this._targetImage.dataset.action = DATA_ZOOM;

        this._targetImageWrap.parentNode.replaceChild(this._targetImage, this._targetImageWrap);

        this._overlay.remove();

        this._body.classList.remove(CLASS_NAME_ZOOM_OVERLAY_TRANSITIONING);
      }
    };

    return Zoom;
  }();
  /**
   * ------------------------------------------------------------------------
   * Data Api implementation
   * ------------------------------------------------------------------------
   */


  EventHandler__default['default'].on(window, EVENT_LOAD_DATA_API, function () {
    new ZoomService().listen();
  });
  /**
   * ------------------------------------------------------------------------
   * jQuery
   * ------------------------------------------------------------------------
   * add .Zoom to jQuery only if jQuery is present
   */

  util.defineJQueryPlugin(NAME, Zoom);

  exports.Enter = Enter;
  exports.ImageGrid = ImageGrid;
  exports.Navbar = Navbar;
  exports.Stage = Stage;
  exports.Zoom = Zoom;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=kit.js.map
